using System;
using System.Drawing;
using System.Windows.Forms;

public delegate void SimEventHandler();

class SimController : Panel
{
    private bool simGo;
    private Button b;
    public event SimEventHandler StartSim;
    public event SimEventHandler StopSim;
    
    public SimController()
    {
        this.simGo = false;
        
        this.b = new Button();
        this.b.Text = "Start";
        this.b.Location = new Point(10, 10);
        this.Height = this.b.Height + 20;
        this.b.Click += new EventHandler(bClick);
        this.Controls.Add(b);
    }

    protected void bClick(Object o, EventArgs e)
    {
        if(this.simGo)
        {
            if (this.StopSim != null)
                this.StopSim();
            this.b.Text = "Start";
        }
        else
        {
            if (this.StartSim != null)
                this.StartSim();
            this.b.Text = "Stop";
        }
        
        this.simGo = !this.simGo;
    }
}