using System;
using System.Drawing;
using System.Windows.Forms;

public class testForm : Form
{
    DiningRoom dr;
    
    public testForm()
    {
        // concerning me
        this.Text = "dining philosophers - ultimate version";
        this.Size = new Size(800, 600);
        
        // dining room containg a table with forks and some philosophers
        dr = new DiningRoom();
        dr.BackColor = Color.AliceBlue;
        
        // sim control, add eventhandler for philosophers control
        SimController sc = new SimController();
        
        sc.StartSim += new SimEventHandler(dr.StartSupper);
        sc.StopSim += new SimEventHandler(dr.StopSupper);

        sc.Dock = DockStyle.Top;
        dr.Dock = DockStyle.Fill;
        
        // add controls at last to not corrupt z-order and docking style
        this.Controls.Add(dr);
        this.Controls.Add(sc);        
    }

    protected override void  OnClosing(System.ComponentModel.CancelEventArgs e)
    {
 	     base.OnClosing(e);
         dr.StopSupper();
    }
}